﻿using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using System.Linq;
using System.Text;

namespace Export_WebGrid_CSV_MVC_Core.Controllers
{
    public class HomeController : Controller
    {
        private DBCtx Context { get; }

        public HomeController(DBCtx _context)
        {
            this.Context = _context;
        }

        public IActionResult Index()
        {
            return View(this.Context.Customers.Take(10).ToList());
        }

        [HttpPost]
        public FileResult Export()
        {
            string[] columnNames = new string[] { "CustomerId", "ContactName", "City", "Country" };
            var customers = this.Context.Customers.Take(10).ToList();

            //Build the CSV file data as a Comma separated string.
            string csv = string.Empty;

            foreach (string columnName in columnNames)
            {
                //Add the Header row for CSV file.
                csv += columnName + ',';
            }

            //Add new line.
            csv += "\r\n";

            foreach (var customer in customers)
            {
                //Add the Data rows.
                csv += customer.CustomerID.Replace(",", ";") + ',';
                csv += customer.ContactName.Replace(",", ";") + ',';
                csv += customer.City.Replace(",", ";") + ',';
                csv += customer.Country.Replace(",", ";") + ',';

                //Add new line.
                csv += "\r\n";
            }

            //Download the CSV file.
            byte[] bytes = Encoding.ASCII.GetBytes(csv);
            return File(bytes, "text/csv", "Grid.csv");
        }
    }
}